package org.wso2.solutions.identity.sts;

import javax.xml.namespace.QName;

import org.apache.axiom.om.OMElement;

public class IdentityProviderUtil {

	
	
	public static OMElement createRequestedDisplayToken(OMElement parent, IdentityProviderData data){

		return createOMElement(parent,
				IdentityConstants.IDENTITY_NAMESPACE ,
				IdentityConstants.LocalNames.REQUESTED_DISPLAY_TOKEN,
				IdentityConstants.IDENTITY_PREFIX);
	}
	
	public static OMElement createDisplayToken(OMElement parent, IdentityProviderData data){
		
		OMElement displayElem = createOMElement(parent,
				IdentityConstants.IDENTITY_NAMESPACE ,
				IdentityConstants.LocalNames.DISPLAY_TOKEN,
				IdentityConstants.IDENTITY_PREFIX);
		
		
		
		return displayElem;
		
	}
	
	public static OMElement createDisplayClaim(OMElement parent, String displayTag, String displayValue){
		OMElement claimElem = createOMElement(parent,
				IdentityConstants.IDENTITY_NAMESPACE ,
				IdentityConstants.LocalNames.DISPLAY_CLAIM,
				IdentityConstants.IDENTITY_PREFIX);
		
		
		OMElement tagElem = createOMElement(claimElem,
				IdentityConstants.IDENTITY_NAMESPACE ,
				IdentityConstants.LocalNames.DISPLAY_TAG,
				IdentityConstants.IDENTITY_PREFIX);
		tagElem.setText(displayTag);
		
		OMElement valElem = createOMElement(claimElem,
				IdentityConstants.IDENTITY_NAMESPACE ,
				IdentityConstants.LocalNames.DISPLAY_VALUE,
				IdentityConstants.IDENTITY_PREFIX);
		valElem.setText(displayValue);
		
		
		return claimElem;
	}
	
	
	
	
	
	private static OMElement createOMElement(OMElement parent,
			String ns,
			String ln,
			String prefix) {
		
		
		return parent.getOMFactory().createOMElement(new QName(ns, ln, prefix),
				parent);
		
	}

}
