package org.wso2.solutions.identity.sts.users;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.UnsupportedCallbackException;

import org.apache.ws.security.WSPasswordCallback;
import org.wso2.solutions.identity.sts.IPUser;
import org.wso2.usermanager.PrincipalNotFoundException;
import org.wso2.usermanager.UserManager;
import org.wso2.usermanager.realm.generic.GenericJNDIRealm;
import org.wso2.usermanager.service.UserManagerService;


public class IPPasswordCallback implements CallbackHandler {
	

    public void handle(Callback[] callbacks) throws IOException,
            UnsupportedCallbackException {
        for (int i = 0; i < callbacks.length; i++) {
            WSPasswordCallback pwcb = (WSPasswordCallback)callbacks[i];
            if(pwcb.getUsage() == WSPasswordCallback.USERNAME_TOKEN_UNKNOWN){
            	String username = pwcb.getIdentifer();
            	String passwd = pwcb.getPassword();
            	if(passwd!=null){
            		IPUser user = this.authenticate(username, passwd);
                   	if(passwd.equals(user.getPassword())){
                   		return;
                   	}
            	}
            	throw new UnsupportedCallbackException(pwcb);
            }
        }
    }
    
    /**
     * This method will get a user from UserManager service.
     * @param username
     * @param passwd
     * @return
     */
    public IPUser authenticate(String username, String passwd){
    	IPUser user = null;
    	//TODO:: put these things into a configuration file
    	GenericJNDIRealm realm = new GenericJNDIRealm();
		
		realm.setConnectionName("cn=root,dc=wso2,dc=com");
		realm.setConnectionPassword("secret");
		realm.setConnectionURL("ldap://10.100.1.138");
		
		realm.setDigestAlgo("MD5");
		realm.setPasswordAttrId("userPassword");

		Map map = new HashMap();

		map.put("password", "userPassword");
		map.put("name", "givenName");
		
		realm.setUserPattern("uid={0},ou=People,dc=wso2,dc=com");
		realm.configureUserBaseDriver(map, "org.wso2.solutions.identity.sts.users.IPUser");
		
    	try {
			user = (IPUser) realm.authenticateUser(username, passwd);
			
		} catch (PrincipalNotFoundException e) {
			e.printStackTrace();
		}
      	return user;
    }
    
    
}