#include "cspace_utils.h"

/* c shoule always be a hex digit.*/
int hex2dec(const char c) {
    /*we need not worry about lower bound since we know it is hex*/

    /*keep the order intact, logic depends on the order*/
    if (c <= '9') {
        return c - '0';
    } else if (c <= 'F') {
        return c - 'A' + 10;
    } else if (c <= 'f') {
        return c - 'a' + 10;
    }
    return 0; /* this should never be reached.*/
}


void cspace_decode_url(char *url) {
    char *s = url, *d = url; /*source and destination pointers*/

    while (*s) {
        if (*s == '+') { /*this should come first:
                           we don't want to mess with the url encoded '+'s */
            *d = ' ';
        } else if (*s=='%' && isxdigit(*(s+1)) && isxdigit(*(s+2))) {
            *d = ((hex2dec(*(s+1))) * 16) + hex2dec(*(s+2));
            s += 2;
        } else {
            *d = *s;
        }
        d ++;
        s ++;
    }
    *d = '\0';
}

