#include <string.h>
#include <stdio.h>
#include <axis2_client.h>
#include <axiom_document.h>
#include <axiom_node.h>
#include <axiom_stax_builder.h>
#include <axiom_xml_reader.h>
#include <axis2_util.h>
#include <axis2_env.h>
#include <oxs_ctx.h>
#include <oxs_utility.h>
#include <oxs_key.h>
#include <oxs_asym_ctx.h>
#include <oxs_axiom.h>
#include <oxs_token_encryption_method.h>

#define NCSPACE_DEBUG

#define SUCC 1
#define FAIL !SUCC

#define CSPACE_XML_TOKEN "xmlToken="
#define CSPACE_TVS_ACTION "urn:verify"

#define CSPACE_STATE_AUTHED 100
#define CSPACE_STATE_PENDING 200

/*TVS - Token Verifier Service*/

/*TODO: find objects that needs to be created per request and make them 
 *      local to fns*/
typedef struct {
    const axis2_env_t *env;
    axis2_allocator_t *allocator;
    axiom_document_t *doc;
    axiom_xml_reader_t *reader;
    axiom_stax_builder_t *builder;
    axiom_node_t *node;
    char *key_file;

    axis2_svc_client_t *svc_client;
    axis2_options_t *options;
    axis2_endpoint_ref_t *epr;
} process_ctx_t;


typedef void (*hash_set_cb_t)(char *, char *, void*);

process_ctx_t* cspace_process_ctx_create(void *pool); 

int cspace_process_request(process_ctx_t *ctx, char *req, char *key_file,
        char *epr, void *ret_hash, hash_set_cb_t cb);
