/*
 * Copyright 2004,2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.relyingparty;

/**
 *
 * @author Ruchith Fernando (ruchith.fernando@gmail.com)
 */
public class RPConstants {
    public final static String SAML_ATTR_GIVENNAME = "givenname";
    public final static String SAML_ATTR_SURNAME = "surname";
    public final static String SAML_ATTR_EMALADDR = "emailaddress"; 
    public final static String SAML_ATTR_PPID = "privatepersonalidentifier";
    
    public final static String SERVICE_CONFIG_SMTP_HOST = "mail.smtp.host";
    public final static String SERVICE_CONFIG_SMTP_PORT = "mail.smtp.port";
    public final static String SERVICE_CONFIG_FROM_ADDRESS = "mail.from.address";
    public final static String SERVICE_CONFIG_FROM_SUBJECT = "mail.from.subject";

    
    /**
     * Namespace of the response
     */
    public final static String NS = "http://ns.wso2.org/relyingparty";
    
    /**
     * Namespace prefix
     */
    public final static String PREFIX = "rp";

    /**
     * Response element local name
     */
    public final static String LN_RESP = "VerifierResponse";
    
    /**
     * Request element local name
     */
    public final static String LN_REQ = "VerifierRequest";
    
    /**
     * Token element local name
     */
    public final static String LN_TOKEN = "Token";
    
    public final static String LN_ISSUER = "Issuer";
    
    /**
     * Property element local name
     */
    public final static String LN_PROPERTY = "Property";
    
    /**
     * Name attribute of the <code>Property</code> element
     */
    public final static String ATTR_NAME = "Name";

    public final static String ATTR_STATE = "State";
    
    public final static String ISSUER_SELF = "self";
    public final static String ISSUER_MANAGED = "managed";
    
    //Response states
    
    public final static String STATE_AUTHENTICATED = "authenticated";
    public final static String STATE_NEW_USER_CONFIRMATION_PENDING = "newUserConfirmationPending";

}
