/*
 * Copyright 2004,2005 The Apache Software Foundation.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.relyingparty;

import org.w3c.dom.Element;

import javax.xml.parsers.DocumentBuilderFactory;

import java.io.InputStream;

import junit.framework.TestCase;

/**
 *
 * @author Ruchith Fernando (ruchith.fernando@gmail.com)
 */
public class TokenVerifierTest extends TestCase {

    private String samlTokenPath = "saml.xml";
    
    public void testVerifyDecryptedToken() throws Exception {
        InputStream is = TokenVerifierTest.class.getClassLoader().getResourceAsStream(samlTokenPath);
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        dbf.setNamespaceAware(true);
        Element elem = dbf.newDocumentBuilder().parse(is).getDocumentElement();
        TokenVerifier verifier = new TokenVerifier();
        assertTrue("Cannot verify decrypted saml token", verifier.verifyDecryptedToken(elem));        
    }
    
}
